VCS: https://gitlab.cern.ch/acron/arc/-/tree/f229cc6939ec84b6e6767d3014445a0ae17026c4
# Make sure RPM doesn't complain about installed but non-packaged files.
%define __check_files  %{nil}

# Don't strip files - rpm magic ?!?!?
%define debug_package %{nil}
%define __spec_install_post %{nil}

# arcd has trouble building on C8/openafs-1.8. Drop it (and the whole arc-server)
%if 0%{?rhel} <= 7
%define build_arcd 1
%else
%define build_arcd 0
%endif

Summary: Authenticated Remote Command
Name: arc
Version: 49
Release: 1.0%{?dist}
Epoch: 0
License: GPLv2
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Rainer Toebbicke <Rainer.Toebbicke@cern.ch>
Vendor: Scientific Linux
URL: https://gitlab.cern.ch/acron/arc/
Group: Networking/misc
BuildRequires: gcc krb5-devel krb5-libs openssl-devel perl(Pod::Man)
%if 0%{?rhel} <= 8
Requires: openssl perl-Authen-PAM sssd-client
%else
Requires: openssl perl-Authen-PAM sssd-client perl-diagnostics
%endif

# keytabs are pregenerated on CERN systems
#Requires(post): cern-config-keytab

Source0: http://afs/cern.ch/project/afs/dev/arc/arc-src.tar.bz2
Source1: acron.pam

%description
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into a
perl program on the server side. It is up to the perl program to act according
to the certified identity of the caller.

%package client
Summary: arc client side including some arc-based utilities
Group: Networking/misc

%description client
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into a
perl program on the server side. It is up to the perl program to act according
to the certified identity of the caller.

%if %{build_arcd}
%package server
Requires: cern-get-keytab xinetd arc
BuildRequires: openafs-devel < 1.8
Summary: arc - server side
Group: Networking/misc

%description server
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into
a perl program on the server side. It is up to the perl program to
act according to the certified identity of the caller.
%endif
###############################################################################
#
# preparation
#
###############################################################################

%prep

%setup -q -c -n %{name}-%{version}

###############################################################################
#
# building
#
###############################################################################

%build

cd src

cp -vf %{SOURCE1} acron.pam

make arc
make man
%if %{build_arcd}
make arcd
%endif
###############################################################################
#
# installation
#
###############################################################################

%install

# Build install tree
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}/arcd
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d

mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 0755 src/arc $RPM_BUILD_ROOT%{_bindir}
install -m 0755 src/acrontab $RPM_BUILD_ROOT%{_bindir}
%if %{build_arcd}
install -m 0755 src/arcd $RPM_BUILD_ROOT%{_sbindir}
%endif
install -m 0644 src/arcd.xinetd $RPM_BUILD_ROOT/etc/xinetd.d/arcd

install -m 0644 src/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1
gzip  $RPM_BUILD_ROOT/%{_mandir}/man1/*.1

install -m 0744 src/arcd.pl $RPM_BUILD_ROOT/%{_libexecdir}/arcd
install -m 0555 src/krb5.conf.cern_mini $RPM_BUILD_ROOT%{_libexecdir}/arcd
install -m 0644 src/logrotate.d_arc $RPM_BUILD_ROOT/etc/logrotate.d/arc
umask 0077
echo "# this file contains Kerberos principals of superusers, one per line" > $RPM_BUILD_ROOT/%{_libexecdir}/arcd/ACL

# configs
install -m 0555 src/arcd.arc $RPM_BUILD_ROOT/%{_libexecdir}/arcd/arcd.arc
install -m 0555 src/akron.arc $RPM_BUILD_ROOT/%{_libexecdir}/arcd/akron.arc
install -m 0644 src/acron.acl $RPM_BUILD_ROOT/%{_libexecdir}/arcd/acron.acl
install -m 0644 src/acron.pam $RPM_BUILD_ROOT/etc/pam.d/acron

%clean
echo "Cleaning $RPM_BUILD_ROOT"
[ "$RPM_BUILD_ROOT" != "/" -a "x%{debugspec}" != "x1" ] && \
	rm -fr $RPM_BUILD_ROOT


###############################################################################
###
### scripts
###
###############################################################################
%post
grep -q -P '^arc\s*4241/tcp' /etc/services || \
    echo "arc	4241/tcp	# Authenticated Remote Control" >> /etc/services

%if %{build_arcd}
%post server
# undoing broken selinux attempts of previous versions
if [ -x /usr/bin/chcon ]; then
  /usr/bin/chcon system_u:object_r:bin_t:s0 /usr/sbin/arcd || true
fi

# and
if [ -x /usr/sbin/semanage ]; then
    /usr/sbin/semanage fcontext -d -t rshd_exec_t /usr/sbin/arcd 2>/dev/null || true
fi
# and
if [ -x /sbin/restorecon ]; then
    /sbin/restorecon /usr/sbin/arcd || true
fi
/sbin/chkconfig arcd on

%preun server
[ "$1" = 0 ] && /sbin/chkconfig arcd off
true

%endif

%files
%{_bindir}/arc
%{_bindir}/acrontab
%{_mandir}/man1/arc.1*
%{_mandir}/man1/acrontab.1*

%if %{build_arcd}
%files server
%defattr(-,root,root)
%attr(0555,root,root) %{_sbindir}/arcd
%attr(0544,root,root) %{_libexecdir}/arcd/arcd.pl
%attr(0644,root,root) %{_libexecdir}/arcd/krb5.conf.cern_mini

%attr(0600,root,root)%config(noreplace) /etc/xinetd.d/arcd
%attr(0644,root,root)%config(noreplace) /etc/logrotate.d/*
%attr(0444,root,root)%config(noreplace) %{_libexecdir}/arcd/ACL
%attr(0644,root,root)%config(noreplace) /etc/pam.d/*

%attr(0555,root,root)%config(noreplace) %{_libexecdir}/arcd/arcd.arc
%attr(0555,root,root)%config(noreplace) %{_libexecdir}/arcd/akron.arc
%attr(0444,root,root)%config(noreplace) %{_libexecdir}/arcd/acron.acl
%endif

%changelog
* Mon Jan 16 2023 Gavin McCance <gavin.mccance@cern.ch> - 49.1.0
- drop warning to move to acron service for now

* Mon Apr 11 2022 Jan Iven <jan.iven@cern.ch> - 48.1.3
- drop ExclusiveArch so can build on aarch64. If we want to.

* Wed Mar 02 2022 Ulrich Schwickerath <ulrich.schwickerath@cernch> - 48.1.2
- leave obsoletion warning when editing

* Tue May 18 2021 Ulrich Schwickerath <ulrich.schwickerath@cernch> - 48.1.1
- import opt_r here as well
- fix for _cron_select calls

* Wed Apr 21 2021 Jan Iven <Jan.iven@cernch> - 47.1.1
- switch to File:tempfile for acrontab

* Wed Apr 21 2021 Jan Iven <jan.iven@cernch> - 47.1.0
- drop arcd/arc-server on C8/openafs-18
- drop non-MIT support and separate 'arc-makefile.mit-nokrb4'
- remove Kerberos4, DES

* Wed Apr 14 2021 Ulrich Schwickerath <Ulrich.Schwickerath@cern.ch> - 46.1.0
- remove dependencies on perl modules

* Wed Apr 14 2021 Ulrich Schwickerath <Ulrich.Schwickerath@cern.ch> 2018.09.05 - 45.1.2
- add support for PAM
- cleanup white spaces

* Wed Apr 14 2021 Ulrich Schwickerath <Ulrich.Schwickerath@cern.ch> 2017.03.30 - 44.40.8
- remove AFS dependencies

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2017.03.30 - 44.40.7
- use direct path for acrontab (ACRON-19)

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2016.08.01 - 44.40.6
- fix post scripts chcon invocation.

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2016.07.29 - 44.40.3
- fix acrontab to look into /afs/cern.ch/usr if /afs/usr not available.

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2014.09.01 - 44.40.2
- change cern-config-keytab dependency to cern-get-keytab

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2014.08.01 - 44.40.1
- rebuild for EL7

* Wed Apr 14 2021 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2013.03.15 - 44.40.1
- remove cern-get-keytab dependency, openafs-compat dependency
- remove post scripts for server

* Wed Apr 14 2021 rtb <Rainer.Toebbicke@cern.ch> 2011.03.21 - 44.40
- put PAG number back in ticket cache name, TCP_LINGER2 also for unauth connections

* Wed Apr 14 2021 rtb <Rainer.Toebbicke@cern.ch> 2011.03.14 - 44.39
- allow for 1 hour between socket shutdown() and arc procedure exit

* Wed Apr 14 2021  Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 2010.10.08 - 44.38
- cern-config-keytab now has it's own package

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.09.30 - 44.37
- ...the monthly cern-config-keytab...

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.09.14 - 44.36
- prevent chcon error message on SLC4 from confusing users

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.08.04 - 44.35
- ...the monthly cern-config-keytab...

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.07.02 - 44.34
- ...we shall overcome...

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.03.09 - 44.32
- ...we shall overcome...

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.03.09 - 44.31
- guess what changed...

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.03.03 - 44.30
- another cern-config-keytab

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.02.09 - 44.29
- another cern-config-keytab

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.02.04 - 44.28
- MIT makefile revamp to avoid including openafs' des library

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.01.22 - 44.27
- KRB5_PLUGIN_NO_HANDLE to detect existance of krb5_get_error_message

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.01.19 - 44.26
- new cern-config-keytab from John

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2010.01.18 - 44.25
- new cern-config-keytab from John

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.03.26 - 44.24
- separate krb4/krb5 things, finally builds also without krb4 libraries

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.03.26 - 44.22
- inet_ntoa needs #include <arpa/inet.h> and correct parameters

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.03.26 - 44.22
- putenv instead of changing environment by hand

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.03.16 - 44.21
- warning when arc not in /etc/services confuses acrontab

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.03.02 - 44.20
- avoid chkconfig off when upgrading

* Wed Apr 14 2021 iven <Jan.Iven@cern.ch> 2009.02.09 - 44.20
- SElinux context for arcd, modelled after rshd

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2009.01.20 - 44.19
- new cern-config-keytab, some tolerance to krb4-inexistence

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2008.10.30 - 44.18
- logrotate (sigh) RHEL4 use size not minsize

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2008.10.30 - 44.17
- logrotate arc.log & acron.log

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2008.08.26 - 44.16
- spec file mod,

* Wed Apr 14 2021 rtb <rtb@mail.cern.ch> 2007.07.03 - 44.15
- New cern-config-keytab
